
/*
 * $Id: LogMeta.cc,v 1.1.1.1 1999/01/27 08:40:44 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "ILog.h"
#include "OLog.h"
#include "LogMeta.h"

LogTagDescr::LogTagDescr():
	theTag(-1), theType(lpNone), theName(0), theVer(-1) {
}

LogTagDescr::LogTagDescr(int aTag, LogEntryType aType, const String &aName, int aVer = 0):
	theTag(aTag), theType(aType), theName(aName), theVer(aVer) {
}

void LogTagDescr::store(OLog &log) const {
	log << theTag << theType << theName << theVer;
}

void LogTagDescr::load(ILog &log) {
	log >> theTag;
	theType = (LogEntryType) log.geti();
	log >> theName >> theVer;
}
