
/*
 * $Id: globals.cc,v 1.1.1.3 1999/02/05 16:51:42 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "polygraph.h"

#include "Clock.h"
#include "Select.h"
#include "PortMgr.h"
#include "StatPing.h"
#include "StatSoft.h"
#include "StatPhaseMgr.h"
#include "Progress.h"
#include "logTags.h"
#include "globals.h"

// record current time and progress info when time changes
class StampOLog: public OLog {
	public:
		virtual void begEntry(int tag);
};

void StampOLog::begEntry(int tag) {

	if (theModTime != TheClock) {
		theModTime = TheClock;
		(*this) << bege(lgPrg) << TheProgress << ende;
	}
	OLog::begEntry(tag);
}

String ThePrgName = "?";
Progress TheProgress;
OLog *TheLog_ = 0;
PortMgr *ThePortMgr = 0;
Select *TheSelect = 0;

StatPing ThePinger(Time::Sec(1));
StatSoft TheSoOftenPinger(Time::Sec(90));
StatPhaseMgr TheStatPhaseMgr;

/* initialization */

int GlobInit::theUseCount = 0;

void GlobInit::init() { 
	Assert(theUseCount == 1);
	TheLog_ = new StampOLog();
	ThePortMgr = 0; // no default
	TheSelect = new Select();
}

void GlobInit::clean() {
	Assert(theUseCount == 0);
	delete TheLog_; TheLog_ = 0;
	delete ThePortMgr; ThePortMgr = 0;
	delete TheSelect; TheSelect = 0;
}
