
/*
 * $Id: LogMeta.h,v 1.1.1.2 1999/02/05 16:51:49 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef LOG_META_H
#define LOG_META_H

#include "String.h"

class ILog;
class OLog;

// strict order, append-only table
typedef enum { 
	lpNone = 0,

	// special "system" types
	lpPrg,
	lpComment,
	lpSymbTable,
	lpFree = 255,

	// user types
	lpUniqId,

	lpHistogram_,
	lpLineHist,
	lpLog2Hist,
	lpTimeHist,
	lpSizeHist,
	lpTimeVsSizeHist,

	lpStatPing,
	lpStatSoft,

	lpStatPhase,

	// end marker
	lpEnd
} LogEntryType;


// holds metadata about log entries
class LogTagDescr {
	public:
		LogTagDescr();
		LogTagDescr(int aTag, LogEntryType aType, const String &aName, int aVer = 0);

		void store(OLog &log) const;
		void load(ILog &log);

	public:
		int theTag;
		LogEntryType theType;
		String theName;
		int theVer;
};

// every log entry has this prefix
class LogEntryPrefix {
	public:
		operator void*() const { return theTag > 0 ? (void*)-1 : 0; }

	public:
		Size theSize;
		int theTag;
};


#endif
