
/*
 * $Id: StatInt.h,v 1.1.1.1 1999/01/27 08:40:44 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef STAT_INT_H
#define STAT_INT_H

#include "Time.h"

// Stats Interval -- something that accumulates stats for a while;
// An interval may be time related, but does not have to be

class StatInt {
	public:
		void start();

	protected:
		Time theIntStart;
};


// StatInt with a time based interval and some logging stuff

class StatClockInt: public StatInt {
	public:
		StatClockInt(Time aPeriod);
		virtual ~StatClockInt() {}

		void checkpoint() { if (endOfInt()) { flush(); restart(); } }

		virtual void flush() = 0; // saves accumulated stats

	protected:
		virtual bool endOfInt() const;
		virtual void restart() { StatInt::start(); }

	protected:
		Time thePeriod;
};

#endif
